#include <cstring>
#include <fstream>
#include "DataBuffer.hpp"

DataBuffer::DataBuffer(int size)
{
    this->Data = new char[size];
    this->Size = size;
}

DataBuffer::DataBuffer(const DataBuffer& buffer)
{   // copy constructor
    this->Data = new char[buffer.Size]; 
    strcpy(this->Data, buffer.Data);
    this->Size = buffer.Size;
}

DataBuffer::~DataBuffer()
{
    delete[] this->Data;
}


DataBuffer& DataBuffer::operator=(const DataBuffer& rhs)
{
    if (this == &rhs){return *this;}

    delete[] this->Data; // get rid of the data in the buffer
    this->Data = new char[rhs.Size];  // prepare space the same size as the buffer we are assigning from
    strcpy(this->Data, rhs.Data); // copy data into new space

    this->Size = rhs.Size; // set size of new buffer
    return *this;
}

void DataBuffer::readFile(std::ifstream& file, int size)
{
    file.read(this->Data, size);
}

void DataBuffer::writeFile(std::ofstream& file, int size)
{
    file.write(this->Data, size);
}
