#include <iostream>
#include "tga_e.hpp"

tga::TGAError::~TGAError(){;}

void tga::TGAError::debug() const
{
    std::cout << "Unknown TGA Error\n";
}

void tga::TypeError::debug() const 
{
    switch (this->type){
    case 0:
	std::cout << "\nERROR:\tNo Image Data Included\n";
	break;
    case 1:
	std::cout << "\nERROR:\tUncompressed, Color-mapped TGA\n";
	    break;
    case 2:
	std::cout << "\nERROR:\tUncompressed, True-color TGA\n";
	break;
    case 3:
	std::cout << "\nERROR:\tUncompressed, Black-and-white TGA\n";
	break;
    case 9:
	std::cout << "\nERROR:\tRun-length encoded, Color-mapped TGA\n";
	break;
    case 10:
	std::cout << "\nERROR:\tRun-length encoded, True-color TGA\n";
	break;
    case 11:
	std::cout << "\nERROR:\tRun-length encoded, Black-and-white TGA\n";
	break;
    default: 
	std::cout << "ERROR:\tUnknown TGA type\n";
    }
    
    std::cout << "DF3 file not created.\n";
    
}

void tga::IOError::debug() const
{
    std::cout << "\nERROR:\tUnable to open " << this->file << "\n"
	      << "DF3 file not created.\n";
}
